<!DOCTYPE html>
<html lang="cs">
  <head>
    <meta charset='UTF-8'>
    <meta name="author" content="Benjamin Verner">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="styles.css">
    <title>
    Easy as ABC
    </title>
  </head>
  <body>
    <ul>
      <li class="menu"><a href="index.html">Úvod</a></li>
      <li class="menu"><a href="solver.html">SAT Solver</a></li>
      <li class="submenu">
        <a class="submenu-button">Konkrétní problémy</a>
        <div class="submenu-elements">
          <a href="pozorovani.html">Pozorování</a>
          <a href="sudoku.html">Sudoku</a>
          <a href="abc.html">Easy as ABC</a>
          <a href="logik.html">Logik</a>
          <a href="slitherlink.html">Slitherlink</a>
        </div>
      </li>
      <li class="menu"><a href="dokumentace.html">Technická dokumentace</a></li>
      <li class="menu"><a href="zaver.html">Závěr</a></li>
      <li class="menu"><a href="citace.html">Citace</a></li>
    </ul>
    <article>
      <h2 id="title">Easy as ABC</h2>
      <img src="abc_example.png" alt="Easy as ABC" class="image">
      <section>
        <h3>Popis problému</h3>
        <p>Easy as ABC je puzzle podobný Sudoku. Máme mřížku NxN, do které je úkolem doplnit písmena A, B, C (pro větší verze i více písmen) tak, aby v každém sloupci a řádku bylo jedno písmeno od každého. Protože takto nezaplníme všechny pozice, zbylá zůstanou volná. Navíc máme pravidlo speciálně pro tento typ problému. Pro některé sloupce či řádky máme určené, které písmeno z daného směru musí být první. Toto pravidlo je znázorněno písmeny vně mřížky.</p>
      </section>
      <section>
        <h3>Pravidla</h3>
        <p>U ABC problému bude generování klauzulí těžší. Jako u Sudoku tu jsou pravidla sloupce a řádku, která vyřešíme stejně, tedy kombinacemi negací všech dvojic pozic pro danou proměnnou.
                Výrazně větši problém bude představovat generování pravidel začínajícího písmena. Pokud si pozice očíslujeme 1-N, pak můžeme nahlédnout, že dané písmeno se musí vyskytovat na maximálně k-té pozici, kde k = N - počet písmen (aby se za ním stihla vyskytnout všechna ostatní písmena). Také pravidlo můžeme intuitivně přepsat do DNF formy následovně (značení
                proměnná.pozice, nulou označuji prázdné pole):</p>
        <p class="formula">(A.1) ∨ (0.1 ∧ A.2) ∨ (0.1 ∧ 0.2 ∧ A.3) ∨ (0.1 ∧ 0.2 ∧ 0.3 ∧ A.4)</p>
        <p>Potíž ovšem je, že algoritmus pracuje s formulí v CNF tvaru. Můj první přístup byl manuálně rozepsat tuto formuli do CNF tvaru. Takovéto přepsání má za efekt exponenciální růst formule, což není ideální řešení. Po rozepsání konkrétní formule bylo však vidět, že některé klauzule získané formule se ve formuli opakují. Po jejich vyřazení jsem došel k finální formě, která je relativně krátká, a zároveň dává logický smysl, pouze by ji bylo těžké nahlédnout:</p>
        <p class="formula">(A.1 ∨ 0.1) ∧ (A.1 ∨ A.2 ∨ 0.2) ∧ (A.1 ∨ A.2 ∨ A.3 ∨ 0.1) ∧ (A.1 ∨ A.2 ∨ A.3 ∨ A.4)</p>
        <p>Obecně se dá tato formule vygenerovat tak, že začneme klausulí, která obsahuje proměnnou písmena a nuly na první pozici. Postupně tvoříme další klausule tak, že vždy přidáme proměnnou písmena na následující pozici, přičemž změníme pozici nuly také na následující pozici. Takto postupujeme do poslední pozice, na které se písmeno může vyskytovat (tedy pozice N - počet písmen). Tato poslední klausule bude obsahovat proměnné písmena na všech možných pozicích (tedy této a všech předcházejících).</p>
        <p>Poslední klausule říká, že na jedné z daných pozic se bude písmeno nacházet. Z pravidla sloupce a řádku máme zajištěno, že se písmeno nachází na právě jedné z těchto pozic. Pro kteroukoliv pozici, kterou si zvolíme, navíc víme, že ve všech klausulích před tou, ve které se poprvé vyskytne, musí platit proměnná nuly - na žádné jiné pozici se písmeno objevit nemůže. Můžeme si všimnout, že takto vždycky musí platit všechny nuly na předcházejících pozicích.</p>
      </section>
    </article>
  </body>
</html>
